<template>
	<view class="pages">
		<u-navbar
			title="动态"
			:autoBack="true"
			 :safeAreaInsetTop="true"
		>
		</u-navbar>
		<view class="tabs-wrap">
			<u-tabs 
			:list="tabsList" 
			lineColor="#00A447" 
			 :activeStyle="{color:'#333','font-weight': '600','font-size':'30rpx'}"
			 :inactiveStyle="{color:'#999'}"
			@click="tabsClick"></u-tabs>
		</view>
		<view class="page-wrap">
			<mescroll-body class="" ref="mescrollRef" @init="mescrollInit" @down="downCallback" @up="upCallback" :down="downOption" :up="upOption">
				<view class="news">
					<view class="news-item u-flex u-col-top u-border-bottom" @click="goNewsDetails(item.id)" v-for="(item,index) in dataList" :key="item.id">
						<view class="pic">
							<u--image class="image" :src="item.mainImg" width="200rpx" height="145rpx"></u--image>
						</view>
						<view class="text">
							<view class="til ellipsis-2">
								{{item.title}}
							</view>
							<view class="time">2023-08-24</view>
						</view>
					</view>
				</view>
			</mescroll-body>
		</view>
	</view>
</template>

<script>
	// 引入mescroll-mixins.js
	import MescrollMixin from "@/uni_modules/mescroll-uni/components/mescroll-uni/mescroll-mixins.js";
	export default {
		mixins: [MescrollMixin], // 使用mixin
		components:{
			
		},
		data() {
			return {
				tabsList:[],
				hasTypeId:false,
				typeId:1,
				dataList:[],
			}
		},
		onLoad() {
			
		},
		methods: {
			/*下拉刷新的回调, 重置列表为第一页 (此处可删,mixins已默认)
			downCallback(){
				this.mescroll.resetUpScroll();
			},
			/*上拉加载的回调*/
			upCallback(page) {
				// 此处可以继续请求其他接口
				// if(page.num == 1){
				// 	// 请求其他接口...
				// }
			
				// 如果希望先请求其他接口,再触发upCallback,可参考以下写法
				if(!this.hasTypeId){
					this.shopNewsType();
					return // 此处return,先获取xx
				}
			
				let pageNum = page.num; // 页码, 默认从1开始
				let pageSize = page.size; // 页长, 默认每页10条

				let params = {
					pageNum : page.num,
					pageSize :  page.size,
					type : this.typeId,
				}
				// console.log('this.params',params);
				this.$u.api.shopNewsList(params).then(data => {
					console.log('data',JSON.parse(JSON.stringify(data)));
					// 接口返回的当前页数据列表 (数组)
					let curPageData = data.data.rows;
					// console.log('curPageData',JSON.parse(JSON.stringify(curPageData)));
					// 接口返回的当前页数据长度 (如列表有26个数据,当前页返回8个,则curPageLen=8)
					let curPageLen = curPageData.length; 
					// 接口返回的总页数 (如列表有26个数据,每页10条,共3页; 则totalPage=3)
					// let totalPage =  data.data.data.totalPage; 
					// 接口返回的总数据量(如列表有26个数据,每页10条,共3页; 则totalSize=26)
					let totalSize = data.data.total; 
					// 接口返回的是否有下一页 (true/false)
					// let hasNext = data.xxx; 
					// console.log('totalPage',totalPage,'curPageLen',curPageLen);
					//设置列表数据
					if(page.num == 1) this.dataList = []; //如果是第一页需手动置空列表
					this.dataList = this.dataList.concat(curPageData); //追加新数据
					// 请求成功,隐藏加载状态
					//方法一(推荐): 后台接口有返回列表的总页数 totalPage
					// this.mescroll.endByPage(curPageLen, totalPage); 
					//方法二(推荐): 后台接口有返回列表的总数据量 totalSize
					this.mescroll.endBySize(curPageLen, totalSize); 
				}).catch(err => {
					this.mescroll.endErr()
					console.log(err)
				});	
			
			},
			/*若希望重新加载列表,只需调用此方法即可(内部会自动page.num=1,再主动触发up.callback)*/
			reloadList() {
				this.mescroll.resetUpScroll();
			},
			shopNewsType(){
				this.$u.api.shopNewsType().then(res=>{
					this.hasTypeId = true;
					this.tabsList = res.data;
					this.typeId =res.data[0].id;
					this.mescroll.resetUpScroll()
					// console.log('res',res);
				}).catch(err=>{
					this.mescroll.endErr()
					console.log('shopNewsType',err.data);
				})
			},
			tabsClick(item){
				this.typeId = item.id;
				this.reloadList()
				// console.log('item',item);
			},
			goNewsDetails(id){
				uni.$u.route('/xushuo/dynamicdetails', {
					id: id
				});
			}
		}
	}
</script>
<style>
page{
	background-color: #F9F9F9;
}
</style>
<style lang="scss" scoped>
.tabs-wrap{
	background-color: #fff;
	margin-bottom: 10rpx;
}
.list-item{
	overflow: hidden;
	width: 48%;
	margin-bottom: 30rpx;
	background-color: #fff;
	.image-wrap{
		margin-bottom: 20rpx;
	}
}
</style>
